SuperStrict

Import MaxGui.Drivers
Import Pub.FreeJoy
Incbin "drums.jpg"

AppTitle="Guitar Hero World Tour Drums" 

?Win32
Const DirSep:String="\"
?MacOS
Const DirSep:String="/"
?

Global setsdir:String
Global window:TGadget
Global canvas:TGadget
Global image:TImage
Global joysticks:TGadget
Global drumsets:TGadget
Global dir:Int
Global t:String
Global i:Int
Global RedDrum:TSound
Global BlueDrum:TSound
Global GreenDrum:TSound
Global YellowDrum:TSound
Global OrangeDrum:TSound
Global BassDrum:TSound

window=CreateWindow("GHWT Drums",40,40,270,458,Null,WINDOW_TITLEBAR)
canvas=CreateCanvas(0,32,270,400,window)
joysticks=CreateComboBox(4,4,120,22,window)
drumsets=CreateComboBox(130,4,120,22,window)

image=LoadImage("incbin::drums.jpg")
CreateTimer(60)

'load joysticks
If Not JoyCount() Then
	Notify "No joystick found!"
	End
End If
For i = 1 To JoyCount()
	AddGadgetItem(joysticks,JoyName(i))
Next
SelectGadgetItem(joysticks,0)

'load drumsets
setsdir = CurrentDir()
If setsdir[setsdir.Length-1] <> DirSep Then
	setsdir = setsdir + DirSep
End If
setsdir = setsdir + "sets" + DirSep
dir=ReadDir(setsdir)
If Not dir Then
	Notify("There is no directory called ~qsets~q")	
	End
End If
Repeat
	t=NextFile(dir)
	If t="" Exit
	If t="." Or t=".." Continue
	AddGadgetItem(drumsets,t)	
Forever
CloseDir(dir)
SelectGadgetItem(drumsets,0)
LoadDrums(GadgetItemText(drumsets,0))

'main loop
While True
	WaitEvent 
	Select EventID()
		Case EVENT_WINDOWCLOSE
			FreeGadget canvas
			End
		Case EVENT_GADGETACTION
			If EventSource()=drumsets Then
				LoadDrums(GadgetItemText(drumsets,EventData()))
			End If
			If EventSource()=joysticks Then
				'EventData()
			End If
		Case EVENT_MOUSEDOWN
		Case EVENT_TIMERTICK
			RedrawGadget(canvas)
		Case EVENT_GADGETPAINT
			SetGraphics(CanvasGraphics(canvas))
			SetClsColor(255,255,255)
			Cls
			DrawImage(image,0,20)
			Flip
	End Select
	If JoyHit(1, SelectedGadgetItem(joysticks)) Then PlayDrum(GreenDrum)'OK
	If JoyHit(2, SelectedGadgetItem(joysticks)) Then PlayDrum(RedDrum) 'OK
	If JoyHit(3, SelectedGadgetItem(joysticks)) Then PlayDrum(YellowDrum)'OK
	If JoyHit(4, SelectedGadgetItem(joysticks)) Then PlayDrum(BassDrum) 'OK
	If JoyHit(5, SelectedGadgetItem(joysticks)) Then PlayDrum(OrangeDrum) 'OK
	If JoyHit(0, SelectedGadgetItem(joysticks)) Then PlayDrum(BlueDrum)'OK
Wend

Function PlayDrum(s:TSound)
	If s <> Null Then PlaySound(s)
End Function

Function LoadDrums(set:String)
	RedDrum=Null
	BlueDrum=Null
	GreenDrum=Null
	YellowDrum=Null
	OrangeDrum=Null
	BassDrum=Null
	GCCollect()
	Print(setsdir + set + DirSep + "red.wav")
	RedDrum=LoadSound(setsdir + set + DirSep + "red.wav")
	BlueDrum=LoadSound(setsdir + set + DirSep + "blue.wav")
	GreenDrum=LoadSound(setsdir + set + DirSep + "green.wav")
	YellowDrum=LoadSound(setsdir + set + DirSep + "yellow.wav")
	OrangeDrum=LoadSound(setsdir + set + DirSep + "orange.wav")
	BassDrum=LoadSound(setsdir + set + DirSep + "bass.wav")
End Function